﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace xamTree_PropertyToNodeAndDeleteNotify
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
           
            //InitializeComponent();
            //Window1 n = new Window1();
            //n.Show();
            //n.Topmost = true;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
           //var dsa =  xamDataTree1.Nodes[0].NodeLayout
           //  xamDataTree1.Nodes[0].Control.Tag
        }

    }


    public class DataUtil
    {
        private static ObservableCollection<Product> products;
        public class Product : INotifyPropertyChanged
        {
            public event PropertyChangedEventHandler PropertyChanged;

            protected virtual void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
                }
            }

            private int productID;
            private string productName;
            private ObservableCollection<Product> products;


            public int ProductID
            {
                get
                {
                    return this.productID;
                }
                set
                {
                    if (this.productID != value)
                    {
                        this.productID = value;
                        OnPropertyChanged("ProductID");
                    }
                }
            }

            public string ProductName
            {
                get
                {
                    return this.productName;
                }
                set
                {
                    if (this.productName != value)
                    {
                        this.productName = value;
                        OnPropertyChanged("ProductName");
                    }
                }
            }

            public ObservableCollection<Product> Products
            {
                get
                {
                    if (products == null)
                    {
                        products = new ObservableCollection<Product>();
                    }

                    return this.products;
                }

                set
                {
                    products = value;
                }
            }
        }

        private static ObservableCollection<Product> CreateProducts()
        {
            return new ObservableCollection<Product>
            {
                new Product
                {
                    ProductID = 1,
                    ProductName = "Chai",
                    
                },

                new Product
                {
                    ProductID = 2,
                    ProductName = "Chang",
                    
                },

                new Product
                {
                    ProductID = 24,
                    ProductName = "Guaraná Fantástica",
                    
                },

                new Product
                {
                    ProductID = 22,
                    ProductName = "Gustaf's Knäckebröd",
                  
                },

                new Product
                {
                    ProductID = 23,
                    ProductName = "Tunnbröd",

                },

            };
        }


        private static ObservableCollection<Product> CreateProductsList()
        {

            ObservableCollection<Product> innerProducts = CreateProducts();
          
            Product sibling1 = new Product();
            sibling1.ProductName = "First sibling";
            sibling1.Products = innerProducts;

            Product sibling2 = new Product();
            sibling2.ProductName = "Second sibling";
            sibling2.Products = innerProducts;


            Product parent = new Product();
            parent.ProductName = "Parent";
            parent.Products = innerProducts;
            parent.Products.Add(sibling1);
            parent.Products.Add(sibling2);

            ObservableCollection<Product> outerProducts = new ObservableCollection<Product>();
            outerProducts.Add(parent);
            return outerProducts;
        }

        public static ObservableCollection<Product> GetProducts
        {
            get
            {
                if (products == null)
                    products = CreateProductsList();

                return products;
            }
        }
    }
}
